# Introduction

The MediaLibrary module allows you to save all your `image`, `file`, `movie` or `audio` files in one place. We call these files `MediaItem` entities. 
A `MediaGroup` is a collection of `MediaItem` entities. You can use MediaGroup entities in your custom module entities.

```php
class BlogArticle
{
    /**
     * @var MediaGroup
     */
    private $images;

    /**
     * @var MediaGroup
     */
    private $trailers;
}
```

> [Read more about the module structure.](02.%20module%20structure.md)

## Frontend widgets

In the frontend you can choose how you wish to show the MediaGroup entities.

**Default media widgets**

* **Lightbox** ([php](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Widgets/Lightbox.php), [html](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Layout/Widgets/Lightbox.html.twig)) - clicking a thumbnail will open a lightbox
* **Listing** ([php](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Widgets/Listing.php), [html](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Layout/Widgets/Listing.html.twig)) - a list `<ul>` containing the links to the source files
* **OneImage** ([php](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Widgets/OneImage.php), [html](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Layout/Widgets/OneImage.html.twig)) - the first image will be shown
* **OneRandomImage** ([php](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Widgets/OneRandomImage.php), [html](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Layout/Widgets/OneRandomImage.html.twig)) - randomly pick one image from your MediaGroup
* **Slider** ([php](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Widgets/Slider.php), [html](https://github.com/forkcms/forkcms/blob/master/src/Frontend/Modules/MediaLibrary/Layout/Widgets/Slider.html.twig)) - thumbnails will be created to show a slider

**Custom media widgets**

This is the best part. Everything is so flexible. Nothing is holding you back from creating your own amazing media widget. The widget can be placed in your own custom module.

[How to create custom frontend widgets?](03.%20integrating%20in%20your%20module.md)
