# Fork CMS Documentation

[![Slack Status](https://fork-cms.herokuapp.com/badge.svg)](https://fork-cms.herokuapp.com/)

You can find the documentation for Fork CMS here. A more user friendly version can be read on [http://docs.fork-cms.com](http://docs.fork-cms.com)

## Contributing

Want to help improving our documentation? Check out the dedicated article about contributing. See [contribute/03. documentation](06.%20contribute/06.%20documentation.md) for details.

Questions? Feel free to discuss on our [Slack channel](https://fork-cms.herokuapp.com/)


## Table of Contents

### 1. Installation
1. [Download, upload & installation](01.%20installation/01.%20installation.md)
1. [Installation Wizard](01.%20installation/02.%20installation_wizard.md)
1. [Minimum requirements](01.%20installation/03.%20minimum_requirements.md)
1. [Webservers](01.%20installation/04.%20webservers.md)
1. [Upgrading](01.%20installation/05.%20upgrading.md)
1. [Version control](01.%20installation/06.%20version_control.md)
1. [Docker](01.%20installation/07.%20docker.md)
1. [Faq](01.%20installation/08.%20faq.md)

### 2. Getting started
1. [Introduction](02.%20getting%20started/01.%20introduction.md)
1. [Adding modules](02.%20getting%20started/02.%20adding_modules.md)
1. [Adding a theme](02.%20getting%20started/03.%20adding_a_theme.md)
1. [Spam protection](02.%20getting%20started/04.%20spam_protection.md)
1. [Linking Facebook](02.%20getting%20started/05.%20linking_facebook.md)
1. [Enable Twitter cards](02.%20getting%20started/06.%20enable_twittercards.md)
1. [Configuring cronjobs](02.%20getting%20started/07.%20configuring_cronjobs.md)
1. [Publish your website](02.%20getting%20started/08.%20publish_your_website.md)

### 3. User guide
1. [Introduction](03.%20user%20guide/01.%20introduction.md)
1. [Dashboard](03.%20user%20guide/02.%20dashboard.md)
1. [Pages](03.%20user%20guide/03.%20pages.md)
1. [The editor](03.%20user%20guide/04.%20the_editor.md)
1. [Standard modules](03.%20user%20guide/05.%20standard_modules.md)
1. [SEO](03.%20user%20guide/06.%20seo.md)
1. [Marketing](03.%20user%20guide/07.%20marketing.md)
1. [Mailmotor](03.%20user%20guide/08.%20mailmotor.md)
1. [Settings](03.%20user%20guide/09.%20settings.md)

### 4. Theming guide
1. [Introduction](04.%20theming%20guide/01.%20introduction.md)
1. [What is a theme within fork?](04.%20theming%20guide/02.%20what_is_a_theme_within_fork.md)
1. [Theme contents](04.%20theming%20guide/03.%20theme_contents.md)
1. [Page templates, positions & blocks](04.%20theming%20guide/04.%20page_templates_positions_and_blocks.md)
1. [Making a basic theme](04.%20theming%20guide/05.%20making_a_basic_theme.md)
1. [Creating a template](04.%20theming%20guide/06.%20creating_a_template.md)
1. [Locale and translations](04.%20theming%20guide/07.%20locale_and_translations.md)
1. [Theme checklist](04.%20theming%20guide/08.%20theme_checklist.md)

### 5. Module guide
1. [Introduction](05.%20module%20guide/01.%20introduction.md)
1. [Applications & Library](05.%20module%20guide/02.%20applications_and_library.md)
1. [Routing](05.%20module%20guide/03.%20routing.md)
1. [Modeling your module](05.%20module%20guide/04.%20modeling_your_module.md)
1. [Writing your module](05.%20module%20guide/05.%20writing_your_module.md)
1. [Blocks and widgets](05.%20module%20guide/06.%20blocks_and_widgets.md)
1. [Templates](05.%20module%20guide/07.%20templates.md)
1. [Translations/Locale](05.%20module%20guide/08.%20translations_or_locale.md)
1. [Forms](05.%20module%20guide/09.%20forms.md)
1. [Data grids](05.%20module%20guide/10.%20data_grids.md)
1. [Generate thumbnails based on folder](05.%20module%20guide/11.%20generate_thumbnails_based_on_folder.md)
1. [Javascript](05.%20module%20guide/12.%20javascript.md)
1. [Ajax](05.%20module%20guide/13.%20ajax.md)
1. [Passing data from PHP to javascript](05.%20module%20guide/14.%20passing_data_from_php_to_javascript.md)
1. [Cronjobs](05.%20module%20guide/15.%20cronjobs.md)
1. [Module settings](05.%20module%20guide/16.%20module_settings.md)
1. [Pagination](05.%20module%20guide/17.%20pagination.md)
1. [Meta data & SEO](05.%20module%20guide/18.%20meta_data_and_seo.md)
1. [Breadcrumbs](05.%20module%20guide/19.%20breadcrumbs.md)
1. [Tags](05.%20module%20guide/20.%20tags.md)
1. [Search](05.%20module%20guide/21.%20search.md)
1. [Creating frontend-widgets](05.%20module%20guide/22.%20creating_frontend_widgets.md)
1. [Events publish and subscribe](05.%20module%20guide/23.%20events_publish_and_subscribe.md)
1. [Creating an installer](05.%20module%20guide/24.%20creating_an_installer.md)
1. [Creating a module.zip file](05.%20module%20guide/25.%20creating_a_module_zip_file.md)
1. [Implementing Twitter Cards](05.%20module%20guide/26.%20twittercards.md)
1. [Symfony Form File](05.%20module%20guide/27.%20symfony_form_file.md)
1. [Symfony Form Image](05.%20module%20guide/28.%20symfony_form_image.md)

### 6. Contribute
1. [Introduction](06.%20contribute/01.%20introduction.md)
1. [Testing](06.%20contribute/02.%20testing.md)
1. [Features](06.%20contribute/03.%20features.md)
1. [Translations](06.%20contribute/04.%20translations.md)
1. [User interface](06.%20contribute/05.%20user_interface.md)
1. [Documentation](06.%20contribute/06.%20documentation.md)
1. [Spreading the word](06.%20contribute/07.%20spreading_the_word.md)
1. [Open sourcing your modules/themes](06.%20contribute/08.%20open_sourcing_fork_cms_modules_and_themes.md)

### 7. Media Library
1. [Introduction](07.%20media%20library/01.%20introduction.md)
1. [Console commands](07.%20media%20library/02.%20module%20structure.md)
1. [Integrating in your module](07.%20media%20library/03.%20integrating%20in%20your%20module.md)
1. [Cropper](07.%20media%20library/04.%20image%20management.md)
1. [Console commands](07.%20media%20library/05.%20console%20commands.md)

